/*
 * Copyright (c) 2022, Kentaro Sekimoto
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  -Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *  -Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef HW_RP2040_MCU_HW_H_
#define HW_RP2040_MCU_HW_H_

#include <stdint.h>
#include <stdbool.h>

void mdelay(uint32_t m);
void mcu_init(void);
void mcu_gpio_mode_output(uint32_t pin);
void mcu_gpio_mode_input(uint32_t pin);
void mcu_gpio_write(uint32_t pin, bool level);
bool mcu_gpio_read(uint32_t pin);
void mcu_spi_write_byte(uint32_t ch, uint8_t dat);
void mcu_spi_init(uint32_t ch, uint32_t mosi, uint32_t miso, uint32_t clk, uint32_t cs, uint32_t speed, uint32_t bits, uint32_t mode);
void mcu_spi_get_conf(uint32_t ch, uint16_t *spcmd, uint8_t *spbr);
void mcu_spi_start_xfer(uint32_t ch, uint16_t spcmd, uint8_t spbr);
void mcu_spi_end_xfer(uint32_t ch);
void mcu_spi_transfer(size_t len, const uint8_t *src, uint8_t *dst);

#endif /* HW_RP2040_MCU_HW_H_ */
